var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Copyright (c) 2017-present, NDLA.
 *
 * This source code is licensed under the GPLv3 license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

import React from 'react';
import PropTypes from 'prop-types';
import BEMHelper from 'react-bem-helper';
import Button from 'ndla-button';
import { Cross } from 'ndla-icons/action';

var classes = new BEMHelper({
  name: 'video-preview',
  prefix: 'c-'
});

export default function PreviewVideo(_ref) {
  var onVideoPreview = _ref.onVideoPreview,
      children = _ref.children;

  return React.createElement(
    'div',
    classes(),
    React.createElement(
      Button,
      _extends({}, classes('close'), {
        stripped: true,
        onClick: function onClick() {
          return onVideoPreview(undefined);
        } }),
      React.createElement(Cross, null)
    ),
    children
  );
}

PreviewVideo.propTypes = {
  children: PropTypes.node,
  onVideoPreview: PropTypes.func.isRequired
};