'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * Copyright (c) 2017-present, NDLA.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * This source code is licensed under the GPLv3 license found in the
                                                                                                                                                                                                                                                                   * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   */

exports.default = PreviewVideo;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBemHelper = require('react-bem-helper');

var _reactBemHelper2 = _interopRequireDefault(_reactBemHelper);

var _ndlaButton = require('ndla-button');

var _ndlaButton2 = _interopRequireDefault(_ndlaButton);

var _action = require('ndla-icons/action');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var classes = new _reactBemHelper2.default({
  name: 'video-preview',
  prefix: 'c-'
});

function PreviewVideo(_ref) {
  var onVideoPreview = _ref.onVideoPreview,
      children = _ref.children;

  return _react2.default.createElement(
    'div',
    classes(),
    _react2.default.createElement(
      _ndlaButton2.default,
      _extends({}, classes('close'), {
        stripped: true,
        onClick: function onClick() {
          return onVideoPreview(undefined);
        } }),
      _react2.default.createElement(_action.Cross, null)
    ),
    children
  );
}

PreviewVideo.propTypes = {
  children: _propTypes2.default.node,
  onVideoPreview: _propTypes2.default.func.isRequired
};