'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBemHelper = require('react-bem-helper');

var _reactBemHelper2 = _interopRequireDefault(_reactBemHelper);

var _ndlaButton = require('ndla-button');

var _ndlaButton2 = _interopRequireDefault(_ndlaButton);

var _shapes = require('./shapes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var classes = new _reactBemHelper2.default({
  name: 'video-search',
  prefix: 'c-'
}); /**
     * Copyright (c) 2017-present, NDLA.
     *
     * This source code is licensed under the GPLv3 license found in the
     * LICENSE file in the root directory of this source tree.
     *
     */

var VideoLoadMoreButton = function VideoLoadMoreButton(props) {
  var videos = props.videos,
      searching = props.searching,
      limit = props.limit,
      translations = props.translations,
      loadMoreVideos = props.loadMoreVideos;


  if (!videos || videos.length === 0 || videos.length % limit !== 0) {
    return null;
  }
  return _react2.default.createElement(
    'div',
    classes('load-videos'),
    _react2.default.createElement(
      _ndlaButton2.default,
      { disabled: searching, onClick: loadMoreVideos },
      searching ? _react2.default.createElement('div', classes('spinner')) : translations.loadMoreVideos
    )
  );
};

VideoLoadMoreButton.propTypes = {
  searching: _propTypes2.default.bool.isRequired,
  videos: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_shapes.BrightcoveShape), _propTypes2.default.arrayOf(_shapes.YouTubeShape)]),
  translations: _propTypes2.default.shape({
    searchPlaceholder: _propTypes2.default.string.isRequired,
    searchButtonTitle: _propTypes2.default.string.isRequired,
    loadMoreVideos: _propTypes2.default.string.isRequired
  }),
  limit: _propTypes2.default.number.isRequired,
  loadMoreVideos: _propTypes2.default.func.isRequired
};

exports.default = VideoLoadMoreButton;