'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ndlaButton = require('ndla-button');

var _ndlaButton2 = _interopRequireDefault(_ndlaButton);

var _reactBemHelper = require('react-bem-helper');

var _reactBemHelper2 = _interopRequireDefault(_reactBemHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright (c) 2016-present, NDLA.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * This source code is licensed under the GPLv3 license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var classes = new _reactBemHelper2.default({
  name: 'video-search',
  prefix: 'c-'
});

var SearchForm = function (_Component) {
  _inherits(SearchForm, _Component);

  function SearchForm(props) {
    _classCallCheck(this, SearchForm);

    var _this = _possibleConstructorReturn(this, (SearchForm.__proto__ || Object.getPrototypeOf(SearchForm)).call(this, props));

    _this.state = {
      query: props.query
    };
    _this.handleQueryChange = _this.handleQueryChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.onKeyPress = _this.onKeyPress.bind(_this);
    return _this;
  }

  _createClass(SearchForm, [{
    key: 'onKeyPress',
    value: function onKeyPress(evt) {
      if (evt.key === 'Enter') {
        this.handleSubmit(evt);
      }
    }
  }, {
    key: 'handleQueryChange',
    value: function handleQueryChange(evt) {
      this.setState({ query: evt.target.value });
    }
  }, {
    key: 'handleSubmit',
    value: function handleSubmit(evt) {
      evt.preventDefault();
      this.props.onSearchQuerySubmit(this.state.query);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          searching = _props.searching,
          translations = _props.translations;

      return _react2.default.createElement(
        'div',
        classes('form'),
        _react2.default.createElement('input', _extends({}, classes('form-query'), {
          type: 'text',
          onChange: this.handleQueryChange,
          onKeyPress: this.onKeyPress,
          value: this.state.query,
          placeholder: translations.searchPlaceholder
        })),
        _react2.default.createElement(
          _ndlaButton2.default,
          _extends({}, classes('form-button'), {
            onClick: this.handleSubmit,
            loading: searching }),
          translations.searchButtonTitle
        )
      );
    }
  }]);

  return SearchForm;
}(_react.Component);

SearchForm.propTypes = {
  query: _propTypes2.default.string,
  searching: _propTypes2.default.bool.isRequired,
  onSearchQuerySubmit: _propTypes2.default.func.isRequired,
  translations: _propTypes2.default.shape({
    searchPlaceholder: _propTypes2.default.string.isRequired,
    searchButtonTitle: _propTypes2.default.string.isRequired
  })
};

SearchForm.defaultProps = {
  query: ''
};

exports.default = SearchForm;