'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * Copyright (c) 2017-present, NDLA.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * This source code is licensed under the GPLv3 license found in the
                                                                                                                                                                                                                                                                   * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   */

exports.default = VideoSearchResultBrightcove;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ndlaUi = require('ndla-ui');

var _ndlaButton = require('ndla-button');

var _ndlaButton2 = _interopRequireDefault(_ndlaButton);

var _ndlaLicenses = require('ndla-licenses');

var _reactBemHelper = require('react-bem-helper');

var _reactBemHelper2 = _interopRequireDefault(_reactBemHelper);

var _PreviewVideo = require('./PreviewVideo');

var _PreviewVideo2 = _interopRequireDefault(_PreviewVideo);

var _shapes = require('./shapes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var classes = new _reactBemHelper2.default({
  name: 'video-search',
  prefix: 'c-'
});

function VideoSearchResultBrightcove(_ref) {
  var video = _ref.video,
      onVideoPreview = _ref.onVideoPreview,
      selectedVideo = _ref.selectedVideo,
      onSelectVideo = _ref.onSelectVideo,
      locale = _ref.locale,
      translations = _ref.translations;

  var active = selectedVideo && selectedVideo.id === video.id ? 'active' : '';
  var license = video.custom_fields && video.custom_fields.license ? (0, _ndlaLicenses.getLicenseByNBTitle)(video.custom_fields.license, locale) : '';
  var thumbnailSource = video.images && video.images.thumbnail ? video.images.thumbnail.src : '';
  return _react2.default.createElement(
    'div',
    _extends({ key: video.id }, classes('list-item', active)),
    _react2.default.createElement(
      'div',
      classes('list-item-inner'),
      _react2.default.createElement('img', { role: 'presentation', alt: 'presentation', src: thumbnailSource }),
      _react2.default.createElement(
        'div',
        classes('information'),
        _react2.default.createElement(
          'h2',
          null,
          video.name || ''
        ),
        _react2.default.createElement(
          'div',
          classes('copyright-author'),
          video.custom_fields && video.custom_fields.licenseinfo ? video.custom_fields.licenseinfo : ''
        ),
        _react2.default.createElement(
          'div',
          classes('license'),
          license.rights ? _react2.default.createElement(_ndlaUi.LicenseByline, { licenseRights: license.rights }) : license
        ),
        _react2.default.createElement(
          _ndlaButton2.default,
          _extends({}, classes('button'), {
            outline: true,
            onClick: function onClick() {
              return onVideoPreview(video);
            } }),
          translations.previewVideo
        ),
        _react2.default.createElement(
          _ndlaButton2.default,
          _extends({}, classes('button'), { onClick: function onClick() {
              return onSelectVideo(video);
            } }),
          translations.addVideo
        )
      )
    ),
    selectedVideo && selectedVideo.id === video.id ? _react2.default.createElement(
      _PreviewVideo2.default,
      { onVideoPreview: onVideoPreview, selectedType: 'brightcove' },
      _react2.default.createElement('iframe', {
        className: 'c-video-preview__video',
        title: selectedVideo.name,
        src: '//players.brightcove.net/' + selectedVideo.account_id + '/BkLm8fT_default/index.html?videoId=' + selectedVideo.id,
        allowFullScreen: true
      })
    ) : ''
  );
}

VideoSearchResultBrightcove.propTypes = {
  license: _shapes.LicenseShape,
  video: _shapes.BrightcoveShape.isRequired,
  onVideoPreview: _propTypes2.default.func.isRequired,
  selectedVideo: _shapes.BrightcoveShape,
  onSelectVideo: _propTypes2.default.func.isRequired,
  locale: _propTypes2.default.string.isRequired,
  translations: _propTypes2.default.shape({
    addVideo: _propTypes2.default.string.isRequired,
    previewVideo: _propTypes2.default.string.isRequired
  })
};