'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * Copyright (c) 2017-present, NDLA.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * This source code is licensed under the GPLv3 license found in the
                                                                                                                                                                                                                                                                   * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   */

exports.default = VideoSearchResultYouTube;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ndlaButton = require('ndla-button');

var _ndlaButton2 = _interopRequireDefault(_ndlaButton);

var _reactBemHelper = require('react-bem-helper');

var _reactBemHelper2 = _interopRequireDefault(_reactBemHelper);

var _PreviewVideo = require('./PreviewVideo');

var _PreviewVideo2 = _interopRequireDefault(_PreviewVideo);

var _shapes = require('./shapes');

var _videoHelpers = require('./videoHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var classes = new _reactBemHelper2.default({
  name: 'video-search',
  prefix: 'c-'
});

function VideoSearchResultYouTube(_ref) {
  var video = _ref.video,
      onVideoPreview = _ref.onVideoPreview,
      selectedVideo = _ref.selectedVideo,
      onSelectVideo = _ref.onSelectVideo,
      translations = _ref.translations,
      locale = _ref.locale;

  var videoData = video.pagemap.videoobject[0];
  var active = selectedVideo && selectedVideo.pagemap.videoobject[0].videoid === videoData.videoid ? 'active' : '';

  return _react2.default.createElement(
    'div',
    _extends({ key: videoData.videoid }, classes('list-item', active)),
    _react2.default.createElement(
      'div',
      classes('list-item-inner'),
      _react2.default.createElement('img', {
        role: 'presentation',
        alt: 'presentation',
        src: videoData.thumbnailurl
      }),
      _react2.default.createElement(
        'div',
        classes('information'),
        _react2.default.createElement(
          'h2',
          null,
          videoData.name
        ),
        _react2.default.createElement(
          'div',
          null,
          translations.publishedDate + ': ' + (0, _videoHelpers.setLocaleDate)(videoData.datepublished, locale)
        ),
        _react2.default.createElement(
          'div',
          null,
          translations.duration + ': ' + (0, _videoHelpers.setYouTubeDuration)(videoData.duration)
        ),
        _react2.default.createElement(
          'div',
          null,
          translations.interactioncount + ': ' + videoData.interactioncount
        ),
        _react2.default.createElement(
          'div',
          null,
          videoData.description
        ),
        _react2.default.createElement(
          _ndlaButton2.default,
          _extends({}, classes('button'), {
            outline: true,
            onClick: function onClick() {
              return onVideoPreview(video);
            } }),
          translations.previewVideo
        ),
        _react2.default.createElement(
          _ndlaButton2.default,
          _extends({}, classes('button'), { onClick: function onClick() {
              return onSelectVideo(video);
            } }),
          translations.addVideo
        )
      )
    ),
    selectedVideo && selectedVideo.pagemap.videoobject[0].videoid === videoData.videoid ? _react2.default.createElement(
      _PreviewVideo2.default,
      { onVideoPreview: onVideoPreview, selectedType: 'youtube' },
      _react2.default.createElement('iframe', {
        className: 'c-video-preview__video',
        title: selectedVideo.title,
        src: selectedVideo.pagemap.videoobject[0].embedurl,
        allowFullScreen: true
      })
    ) : ''
  );
}

VideoSearchResultYouTube.propTypes = {
  video: _shapes.YouTubeShape.isRequired,
  onVideoPreview: _propTypes2.default.func.isRequired,
  selectedVideo: _shapes.YouTubeShape,
  onSelectVideo: _propTypes2.default.func.isRequired,
  locale: _propTypes2.default.string.isRequired,
  translations: _propTypes2.default.shape({
    addVideo: _propTypes2.default.string.isRequired,
    previewVideo: _propTypes2.default.string.isRequired,
    publishedDate: _propTypes2.default.string.isRequired
  })
};