'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.YouTubeShape = exports.BrightcoveShape = exports.LicenseShape = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LicenseShape = exports.LicenseShape = _propTypes2.default.shape({
  short: _propTypes2.default.string.isRequired,
  title: _propTypes2.default.string.isRequired,
  userFriendlyTitle: _propTypes2.default.string.isRequired,
  description: _propTypes2.default.string.isRequired,
  rights: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired
}); /**
     * Copyright (c) 2017-present, NDLA.
     *
     * This source code is licensed under the GPLv3 license found in the
     * LICENSE file in the root directory of this source tree.
     *
     */

var BrightcoveShape = exports.BrightcoveShape = _propTypes2.default.shape({
  id: _propTypes2.default.string.isRequired,
  name: _propTypes2.default.string.isRequired,
  custom_fields: _propTypes2.default.shape({
    licenseinfo: _propTypes2.default.string.isRequired,
    license: _propTypes2.default.string.isRequired
  }),
  images: _propTypes2.default.shape({
    thumbnail: _propTypes2.default.shape({
      src: _propTypes2.default.string.isRequired
    })
  })
});

var YouTubeShape = exports.YouTubeShape = _propTypes2.default.shape({
  pagemap: _propTypes2.default.shape({
    videoobject: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      name: _propTypes2.default.string.isRequired,
      description: _propTypes2.default.string.isRequired,
      videoid: _propTypes2.default.string.isRequired,
      duration: _propTypes2.default.string.isRequired,
      thumbnailurl: _propTypes2.default.string.isRequired,
      embedurl: _propTypes2.default.string.isRequired,
      interactioncount: _propTypes2.default.string.isRequired,
      datepublished: _propTypes2.default.string.isRequired
    }))
  })
});