'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Copyright (c) 2017-present, NDLA.
 *
 * This source code is licensed under the GPLv3 license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

var getLastPage = exports.getLastPage = function getLastPage(search, type) {
  if (type === 'youtube') {
    if (search.queries && search.queries.request.length > 0) {
      return Math.ceil(search.queries.request[0].totalResults / search.queries.request[0].count);
    }
  }
  return 0;
};

var youTubeDurationToSeconds = exports.youTubeDurationToSeconds = function youTubeDurationToSeconds(duration) {
  var match = duration.match(/PT(\d+H)?(\d+M)?(\d+S)?/);

  var hours = parseInt(match[1], 10) || 0;
  var minutes = parseInt(match[2], 10) || 0;
  var seconds = parseInt(match[3], 10) || 0;

  return hours * 3600 + minutes * 60 + seconds;
};

var setLocaleDate = exports.setLocaleDate = function setLocaleDate(date, locale) {
  var newDate = new Date(Date.parse(date));
  var options = { year: 'numeric', month: '2-digit', day: '2-digit' };
  return newDate.toLocaleDateString(locale, options);
};

var setYouTubeDuration = exports.setYouTubeDuration = function setYouTubeDuration(duration) {
  var seconds = youTubeDurationToSeconds(duration);
  if (seconds > 86400) {
    return '24h+ ' + new Date(seconds * 1000).toISOString().substr(11, 8);
  }
  return new Date(seconds * 1000).toISOString().substr(11, 8);
};